package com.hywa.banktest.common;

import com.hywa.banktest.bankframework.utils.rsa.RSAUtils;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component("signUtils")
public class ValidateSignUtils {
    @Value("${ras.target.pub.key}")
    private String targerPubKey;
    @Value("${ras.private.key}")
    private String privateKey;
    @Value("${ras.public.key}")
    private String publicKey;

    @Value("${carbon.ras.privatekey}")
    private String carbonPrivateKey;

    private static final String CHARSET="UTF-8";

    public boolean signVerify(String minStr,String signStr) throws Exception{
        if(null!=signStr && !"".equals(signStr)){
           return RSAUtils.verify(minStr.getBytes(CHARSET),targerPubKey,signStr);
        }
        return false;
    }

    public String sign(String minStr) throws Exception{
        if(null!=minStr && !"".equals(minStr)){
            return RSAUtils.sign(minStr.getBytes(CHARSET),privateKey);
        }
        return null;
    }

    public String signCarbon(String minStr) throws Exception{
        if(null!=minStr && !"".equals(minStr)){
            return RSAUtils.sign(minStr.getBytes(CHARSET),carbonPrivateKey);
        }
        return null;
    }
}
